C
Code by Michael Kupferschmid
C
      SUBROUTINE APPEND(NUNIT)
C     This routine positions the line pointer at the end of the file
C     attached to unit NUNIT so that it can be appended to, without
C     leaving the file closed so that it cannot be written.  It is
C     necessary because gfortran does not permit the simpler
C     locution described on page 162 of Classical Fortran.
C
C     variable  meaning
C     --------  -------
C     I         index on the lines in the file
C     LNUM      number of line just read
C     NUNIT     number of logical I/O unit attached to the file
C
C ------------------------------------------------------------------
C
C     count the lines in the file
      REWIND(UNIT=NUNIT)
      LNUM=0
    2 READ(NUNIT,*,END=1)
      LNUM=LNUM+1
      GO TO 2
C
C     reread those lines without setting the EOF flag
    1 REWIND(UNIT=NUNIT)
      DO 3 I=1,LNUM
           READ(NUNIT,*)
    3 CONTINUE
      RETURN
      END
