C
Code by Michael Kupferschmid
C
      SUBROUTINE ARGLST(LIST,LL,NL,RC)
C     This routine gets a list of integers from the run command.
C
C     RC  meaning
C     --  -------
C      0  all went well
C      1  parse error
C      2  more than LL entries for LIST
C      3  no run-line parameters
C
C     variable  meaning
C     --------  -------
C     ARG       a run-line argument
C     GETARG    unix routine returns a run-line argument
C     IARGC     unix function returns number of run-line arguments
C     J         number of numbers added to LIST by RNGLST
C     L         the length of a parameter
C     LENGTH    function returns index of last nonblank in a string
C     LIST      the list of integers returned
C     LJ        number of LIST elements still empty
C     LL        dimensioned size of LIST
C     N         index on the run-line arguments
C     NARG      number of run-line arguments found
C     NL        number of entries returned in LIST
C     RC        return code; see table above
C     RNGLST    routine parses a range specification
C
C     formal parameters
      INTEGER*4 LIST(LL),RC
C
C     local variables
      CHARACTER*21 ARG
C
C ------------------------------------------------------------------
C
C     find out how many parameters there are
      NARG=IARGC()
      IF(NARG.EQ.0) THEN
         NL=0
         RC=3
         RETURN
      ENDIF
C
C     process them one at a time expanding numbers into LIST
      NL=0
      LJ=LL
      DO 1 N=1,NARG
           CALL GETARG(N,ARG)
           L=LENGTH(ARG,21)
           CALL RNGLST(ARG,L, LIST(NL+1),LJ, J,RC)
           IF(RC.NE.0) RETURN
           NL=NL+J
           LJ=LJ-J
    1 CONTINUE
      RETURN
      END
