C
Code by Michael Kupferschmid
C
      SUBROUTINE BNKCMT(TEXT, L, SKIP)
C     This routine blanks out a comment ending TEXT.
C
C     variable  meaning
C     --------  -------
C     BLANK     the character ' '
C     COM       T => TEXT(K) is part of a comment
C     K         index on the characters of TEXT
C     L         length of TEXT
C     LENGTH    function returns index of last nonblank in a string
C     POUND     the character '#'
C     SKIP      T => the entire line is a comment
C     STAR      the character '*'
C     TEXT      a line of text
C
C     formal parameters
      INTEGER*1 TEXT(L)
      LOGICAL*4 SKIP
C
C     local variables
      INTEGER*1 BLANK/Z'20'/,POUND/Z'23'/,STAR/Z'2A'/
      LOGICAL*4 COM
C
C ------------------------------------------------------------------
C
C     if the line is empty it is not a comment
      IF(L.EQ.0) THEN
         SKIP=.FALSE.
         RETURN
      ENDIF
C
C     report whether the whole line is a comment or not
      SKIP=(TEXT(1).EQ.POUND .OR. TEXT(1).EQ.STAR)
C
C     blank out a comment at the end of the line
      COM=.FALSE.
      DO 1 K=1,L
           IF(TEXT(K).EQ.POUND .OR. TEXT(K).EQ.STAR) COM=.TRUE.
           IF(COM) TEXT(K)=BLANK
    1 CONTINUE
      L=LENGTH(TEXT,L)
      RETURN
      END
