C
Code by Michael Kupferschmid
C
      SUBROUTINE BTD(N,STRING,LS,RC)
C     This routine converts the integer N into numerals
C     right-justified in STRING (Binary To Decimal).
C
C     variable  meaning
C     --------  -------
C     IABS      Fortran function returns |INTEGER*4|
C     K         index on the digits in |N|
C     KFNB      index of the first nonblank digit in STRING
C     LS        the number of characters in STRING
C     M         integer part of what's left of |N| at the moment
C     N         the integer to be converted
C     NUMERL    the digits 0...9
C     RC        return code; 0 => ok, 1 => error
C     STRING    character string returned
C
C     formal parameters
      CHARACTER*1 STRING(LS)
      INTEGER*4 RC
C
C     local variable
      CHARACTER*1 NUMERL(10)/'0','1','2','3','4',
     ;                       '5','6','7','8','9'/
C
C ------------------------------------------------------------------
C
C     if the length of STRING is not positive, something is wrong
      RC=1
      IF(LS.LE.0) RETURN
C
C     convert the absolute value of the number
      M=IABS(N)
      DO 1 K=LS,1,-1
           STRING(K)=NUMERL(1+M-10*(M/10))
           M=M/10
    1 CONTINUE
C     did the digits of the number fit in the spaces allowed?
      IF(M.NE.0) RETURN
C
C     blank out any leading zeros
      DO 2 K=1,LS
           KFNB=K
           IF(STRING(K).NE.'0') GO TO 3
           STRING(K)=' '
    2 CONTINUE
C     the string was all zeros; put the rightmost one back
      STRING(LS)='0'
C
C     insert a "-" if the number is negative
    3 IF(N.LT.0 .AND. KFNB.EQ.1) RETURN
      IF(N.LT.0) STRING(KFNB-1)='-'
      RC=0
      RETURN
      END
