C
Code by Michael Kupferschmid
C
      FUNCTION DDOT(X,Y,N) 
C     This routine computes the dot product of X with Y. 
C
C     variable  meaning
C     --------  -------
C     J         index on the elements of X and Y
C     N         number of elements in X and Y
C     X         one of the vectors in the dot product
C     Y         the other vector in the dot product 
C
      REAL*8 DDOT,X(N),Y(N)
C
C ------------------------------------------------------------------
C
C     check for a sensible value of N
      DDOT=0.D0
      IF(N.LE.0) RETURN
C
C     compute the product
      DO 1 J=1,N
           DDOT=DDOT+X(J)*Y(J)
    1 CONTINUE
      RETURN
      END
