C
Code by Michael Kupferschmid
C
      SUBROUTINE DTB(STRING,LS, N,RC)
C     This routine converts the right-justified numerals in
C     STRING to an integer in N (Decimal To Binary).
C
C     variable  meaning
C     --------  -------
C     K         index on the characters of STRING
C     KFDGT     index of first digit in STRING
C     L         index on the digits in NUMERL
C     LS        the number of characters in STRING
C     N         the integer returned
C     NUMERL    the digits 0...9
C     RC        return code; 0 => ok, 1 => error
C     SIGN      sign of the number
C     STRING    the string of numerals to be converted
C
C     formal parameters
      CHARACTER*1 STRING(LS)
      INTEGER*4 RC
C
C     local variables
      INTEGER*4 SIGN
      CHARACTER*1 NUMERL(10)/'0','1','2','3','4',
     ;                       '5','6','7','8','9'/
C
C ------------------------------------------------------------------
C
C     if the string is empty, something is wrong
      RC=1
      N=0
      IF(LS.LE.0) RETURN
C
C     skip leading blanks
      DO 1 K=1,LS
           KFDGT=K
           IF(STRING(K).NE.' ') GO TO 2
    1 CONTINUE
C     the string is all blanks
      RETURN
C
C     determine the sign and the index of the first digit
    2 IF(STRING(KFDGT).EQ.'-') THEN
        SIGN=-1
        KFDGT=KFDGT+1
        GO TO 3
      ENDIF
      SIGN=+1
      IF(STRING(KFDGT).EQ.'+') KFDGT=KFDGT+1
    3 IF(KFDGT.GT.LS) RETURN
C
C     examine the digits and construct the value of the number
      DO 4 K=KFDGT,LS
C          add in the positional value of the digit
           DO 5 L=1,10
                IF(STRING(K).NE.NUMERL(L)) GO TO 5
                N=N+(L-1)*10**(LS-K)
                GO TO 4
    5      CONTINUE
C          the character is not a digit
           N=0
           RETURN
    4 CONTINUE
C
C     give the value the correct sign
      N=SIGN*N
      RC=0
      RETURN
      END
