C
Code by Michael Kupferschmid
C
      SUBROUTINE ENGTRN(TLS,N,NUNIT, ENGS,RC)
C     This routine returns in ENGS the translations corresponding
C     to the transliterations in TLS.
C
C     variable  meaning
C     --------  -------
C     ENG       a translation read from the dictionary
C     ENGS      the output list of translations
C     HOME      function prepends home directory to a pathname
C     I         index on the words
C     I4        an INTEGER*4 temporary for sorting
C     J         second index on the words for sorting
C     N         number of words
C     NUNIT     unit number to use for the library
C     ORDER     original order of the transliterations
C     RC        0 => all went well; > 0 => transiteration RC wrong
C     T18       a CHARACTER*18 temporary for sorting
C     TL        a transliteration read from the dictionary
C     TLS       the input list of transliterations
C     TLSORT    the alphabetized list of transliterations
C
C     formal parameters
      CHARACTER*18 TLS(*)
      CHARACTER*80 ENGS(*)
      INTEGER*4 RC
C
C     automatic local variables
      INTEGER*4 ORDER(N)
      CHARACTER*18 TLSORT(N)
C
C     other local variables
      CHARACTER*18 TL,T18
      CHARACTER*48 HOME
      CHARACTER*80 ENG
C
C ------------------------------------------------------------------
C
C     remember the original order of the transliterations
      DO 1 I=1,N
           ORDER(I)=I
           TLSORT(I)=TLS(I)
    1 CONTINUE
C
C     alphebetize the transliterations for 1-pass file search
      DO 2 I=1,N-1
      DO 2 J=I+1,N
           IF(TLSORT(J).LT.TLSORT(I)) THEN
              T18=TLSORT(I)
              TLSORT(I)=TLSORT(J)
              TLSORT(J)=T18
              I4=ORDER(I)
              ORDER(I)=ORDER(J)
              ORDER(J)=I4
           ENDIF
    2 CONTINUE
C
C     read the dictionary and extract the translations
      OPEN(UNIT=NUNIT,FILE=HOME('/Utility/hebrew.hsh',19))
      I=1
    4 READ(NUNIT,901,END=5) TL,ENG
  901 FORMAT(A18,T72,A80)
      IF(TL.EQ.TLSORT(I)) THEN
         ENGS(ORDER(I))=ENG
         I=I+1
      ENDIF
      IF(I.LE.N) GO TO 4
      CLOSE(UNIT=NUNIT)
      RC=0
      RETURN
C
C     a transliteration was not found in the file
    5 CLOSE(UNIT=NUNIT)
      RC=ORDER(I)
      RETURN
      END
