C
Code by Michael Kupferschmid
C
      SUBROUTINE FINDST(LINE,LL,STRING,LS, KSTART)
C     This routine returns in KSTART the position in LINE where 
C     STRING begins, or 0 if STRING is not found, or -1 if the
C     parameters don't make sense.
C
C     KSTART  meaning
C     ------  -------
C       -1    bad parameters
C        0    STRING was not found in LINE
C       >0    the position in LINE where STRING begins
C
C     variable  meaning
C     --------  -------
C     KL        index on the characters of LINE
C     KS        index on the characters of STRING
C     KSTART    see table above 
C     LINE      line of text to be searched for STRING
C     LL        number of characters in LINE
C     LS        number of characters in STRING
C     STRING    string to be searched for 
C
      CHARACTER*1 LINE(LL),STRING(LS)
C
C ------------------------------------------------------------------
C
C     eliminate impossible cases
      KSTART=-1
      IF(LL.LE.0 .OR. LS.LE.0 .OR. LL.LT.LS) RETURN
C
C     try to match STRING to LINE 
      DO 1 KL=1,LL-LS+1
           DO 2 KS=1,LS
                IF(STRING(KS).NE.LINE(KL+KS-1)) GO TO 1
    2      CONTINUE
           KSTART=KL
           RETURN
    1 CONTINUE 
C
C     there was no match
      KSTART=0
      RETURN
      END
