C
Code by Michael Kupferschmid
C
      SUBROUTINE GETHSH(MXCH,MXWD, NWD,NS,TRANS,VS,LS)
C     Table the hash codes of Hebrew words in Utility/hebrew.hsh
C     by <transliteration>.
C
C     variable  meaning
C     --------  -------
C     EXIT      system routine stops program with a return code
C     HOME      function prepends home directory to a pathname
C     K         index on the characters of a dictionary word
C     L         numbers of the letters in a dictionary word
C     LS        numbers of the letters in the dictionary words
C     MXCH      allowed word length
C     MXWD      allowed number of words
C     NC        number of characters in a Hebrew word
C     NS        character counts of the words
C     NWD       number of words found
C     TRAN      the transliteration of a dictionary word
C     TRANS     transliterations of the dictionary words
C     V         numbers of the vowels in a dictionary word
C     VS        numbers of the vowels in the dictionary words

      CHARACTER*18 TRAN,TRANS(MXWD)
      CHARACTER*48 HOME
      INTEGER*1 NS(MXWD),VS(MXCH,MXWD),LS(MXCH,MXWD),L(MXCH),V(MXCH)
C
C ------------------------------------------------------------------
C
C     attach the hashed dictionary file
      OPEN(UNIT=1,FILE=HOME('/Utility/hebrew.hsh',19))
      NWD=0
C
C     process the file one line at a time
    4 READ(1,901,END=1) TRAN,NC,(V(K),L(K),K=1,MXCH)
  901 FORMAT(A18,1X,I2,1X,12(2Z2.2))
      NWD=NWD+1
      IF(NWD.GT.MXWD) THEN
         WRITE(0,902) MXWD
  902    FORMAT('more than ',I4,
     ;          ' lines in dictionary; increase MXWD')
         CLOSE(UNIT=1)
         CALL EXIT(0)
      ENDIF
      TRANS(NWD)=TRAN
      NS(NWD)=NC
      DO 3 K=1,MXCH
           VS(K,NWD)=V(K)
           LS(K,NWD)=L(K)
    3 CONTINUE
      GO TO 4
C
C     the end of the dictionary file has been reached
    1 CLOSE(UNIT=1)
      RETURN
      END
