C
Code by Michael Kupferschmid
C
      SUBROUTINE GETMHZ(SPEED)
C     This routine reads /proc/cpuinfo to find processor speed.
C
C     variable  meaning
C     --------  -------
C     RC        return code from SYSTEM
C     SPEED     processor speed in MHz
C     SYSTEM    unix routine issues a command
C     TEXT      input line read from /tmp/cpuinfo
C
      REAL*8 SPEED
      CHARACTER*18 TEXT
      INTEGER*4 RC,SYSTEM
C
C ------------------------------------------------------------------
C
C     parse the "zero-length" /proc file into a real file
      RC=SYSTEM('/bin/rm -f /tmp/cpuinfo')
      IF(RC.NE.0) THEN
         WRITE(0,901) RC
  901    FORMAT('failed to remove /tmp/cpuinfo')
         STOP
      ENDIF
      RC=SYSTEM('/bin/grep "cpu MHz" /proc/cpuinfo > /tmp/cpuinfo')
      IF(RC.NE.0) THEN
         WRITE(0,902) 
  902    FORMAT('cpu MHz not found in /proc/cpuinfo')
         STOP
      ENDIF
C
C     read the processor speed
      OPEN(UNIT=99,FILE='/tmp/cpuinfo')
      READ(99,900,END=1,ERR=1) SPEED
  900 FORMAT(10X,F8.3)
      CLOSE(UNIT=99)
      RETURN
    1 WRITE(0,903)
  903 FORMAT('failed to read processor speed from /tmp/cpuinfo')
      STOP
      END
