C
Code by Michael Kupferschmid
C
      FUNCTION HOME(FYLE,LF)
C     Complete the file name FYLE by prepending /home/userid.
C
C     variable  meaning
C     --------  -------
C     FYLE      incomplete filename
C     GETENV    system routine gets a shell variable if present
C     HDIR      full-path home directory name
C     K         index on the characters of FYLE
C     LF        index of the last noblank in FYLE
C     NAMC      FYLE as separate characters
C     NAME      FYLE as a 24-character word
C     PACKL     routine removes leading and embedded blanks
C
C     formal parameters
      CHARACTER*1 FYLE(LF)
C
C     local variables
      CHARACTER*48 HOME
      CHARACTER*24 HDIR,NAME
      CHARACTER*1 NAMC(24)
      EQUIVALENCE(NAME,NAMC)
C
C ------------------------------------------------------------------
C
C     check for a sensible value of LF
      IF(LF.LT.0 .OR. LF.GT.24) THEN
         HOME='error'
         RETURN
      ENDIF
C
C     copy the filename into NAME
      NAME='                        '
      DO 1 K=1,LF
           NAMC(K)=FYLE(K)
    1 CONTINUE
C
C     get the name of the home directory
      HDIR='                        '
      CALL GETENV('HOME',HDIR)
C
C     construct the full pathname
      HOME=HDIR//NAME
      CALL PACKL(HOME,48) 
      RETURN
      END
