C
Code by Michael Kupferschmid
C
      FUNCTION INTERP(X,DATA,LDATA,NPTS,LAST)
C     This routine interpolates in DATA to approximate the value
C     of Y corresponding to the given X. 
C
C     variable  quantity
C     --------  --------
C     DATA      table of (x,y) pairs 
C     LAST      index in DATA of left end of bin containing X
C     LDATA     leading dimension of DATA
C     NPTS      number of (x,y) pairs in the table
C     SLOPE     slope of the function within the bin containing X
C     TBLBIN    routine returns bin of table where argument falls
C     X         input argument value
C
      REAL*8 INTERP,X,DATA(LDATA,2),SLOPE
C
C ------------------------------------------------------------------
C
C     find the correct bin in the table (end one if X out of range)
      CALL TBLBIN(DATA,LDATA,NPTS,X, LAST )
C
C     interpolate between the end point values
      SLOPE=(DATA(LAST+1,2)-DATA(LAST,2))/
     ;      (DATA(LAST+1,1)-DATA(LAST,1))
      INTERP=DATA(LAST,2)+SLOPE*(X-DATA(LAST,1))
      RETURN
      END
