C
Code by Michael Kupferschmid
C
      SUBROUTINE LISTRN(LINE,L,MXTL, TLC,NTL)
C     This routine lists in the columns of TLC the Hebrew
C     transliterations in LINE, and returns in NTL their
C     number or -1 if there was an error.
C
C     variable  meaning
C     --------  -------
C     IN        T => in a transliteration
C     K         index on the characters of LINE
C     KL        index in LINE of transliteration's leftmost letter
C     KR        index in LINE of transliteration's rightmost letter
C     KT        index on the letters of a transliteration
C     L         length of LINE
C     LINE      input line
C     MXTL      maximum number of transliterations allowed
C     NTL       number of transliterations found in LINE
C     TLC       transliterations found in LINE, as columns
C
C     formal parameters
      CHARACTER*1 LINE(*)
      CHARACTER*1 TLC(18,MXTL)
C
C     local variables
      LOGICAL*4 IN
C
C ------------------------------------------------------------------
C
C     initialize
      KL=0
      KR=0
      NTL=0
      IN=.FALSE.
C
C     search the string from right to left
      DO 1 K=L,1,-1
C          is this the right end of the next transliteration?
           IF(LINE(K).EQ.'>') THEN
              IF(IN) THEN
                 WRITE(0,901)
  901            FORMAT('> encountered while in transliteration')
                 NTL=-1
                 RETURN
              ELSE
                 NTL=NTL+1
                 IF(NTL.GT.MXTL) THEN
                    WRITE(0,902)
  902               FORMAT('too many transliterations on this line')
                    NTL=-1
                    RETURN
                 ENDIF
                 IN=.TRUE.
                 KR=K-1
              ENDIF
           ENDIF
C
C          is this the left end of the current transliteration?
           IF(LINE(K).EQ.'<') THEN
              IF(IN) THEN
                 IN=.FALSE.
                 KL=K+1
C                copy out the transliteration, left to right
                 DO 2 KT=1,18
                      TLC(KT,NTL)=' '
                      IF(KT .LE. KR-KL+1) TLC(KT,NTL)=LINE(K+KT)
    2            CONTINUE
              ELSE
                 WRITE(0,903)
  903            FORMAT('< encountered outside transliteration')
                 NTL=-1
                 RETURN
              ENDIF
           ENDIF
C     and keep searching
    1 CONTINUE
C
C     report any unmatched >
      IF(KR.LT.KL) THEN
         WRITE(0,904)
  904    FORMAT('incomplete transliteration')
         NTL=-1
      ENDIF
      RETURN
      END
