C
Code by Michael Kupferschmid
C
      SUBROUTINE MATRNS(N,LDA,LDB, A, B) 
C     This routine returns in B the transpose of A. 
C     If A and B are the same matrix, it is transposed in-place;
C     if they are different, A is left unchanged.
C
C     variable  meaning
C     --------  -------
C     A         the matrix whose transpose is wanted
C     B         the transpose of A
C     I         index on the rows of A and the columns of B
C     J         index on the columns of A and the rows of B
C     LDA       leading dimension of A
C     LDB       leading dimension of B
C     N         order of the matrices
C     TEMP      temporary used in exchanging elements
C
      REAL*8 A(LDA,N),B(LDB,N),TEMP
C
C ------------------------------------------------------------------
C
C     leave the upper left element where it is
      B(1,1)=A(1,1)
C
C     go across the columns, starting with the second column
      DO 1 J=2,N
C          exchange off-diagonal elements across the diagonal
           DO 2 I=1,J-1
                TEMP=A(I,J)
                B(I,J)=A(J,I)
                B(J,I)=TEMP
    2      CONTINUE
C
C          leave diagonal elements where they are
           B(J,J)=A(J,J)
    1 CONTINUE
      RETURN
      END
