C
Code by Michael Kupferschmid
C
      SUBROUTINE PROMPT(MSG,LM)
C     This routine prompts on unit 0 for input from the keyboard.
C
C     variable  meaning
C     --------  -------
C     DIGIT     a digit of L
C     FMT       object-time format for writing the prompt
C     K         index on the characters of MSG
C     L         number of characters of MSG actually used
C     LM        length of MSG
C     MAX0      Fortran function for larger of INTEGER*4s
C     MIN0      Fortran function for smaller of INTEGER*4s
C     MSG       prompt string
C     NUMERL    the numerals
C
      CHARACTER*1 MSG(LM)
      INTEGER*4 DIGIT
C
      CHARACTER*1 FMT(12)/'(',' ',' ','A','1',
     ;                    ',',1H',1H ,1H',',','$',')'/
      CHARACTER*1 NUMERL(10)/'0','1','2','3','4',
     ;                       '5','6','7','8','9'/
C
C ------------------------------------------------------------------
C
C     deal with a sensible number of characters
      L=MIN0(80,MAX0(0,LM))
      IF(L.EQ.0) RETURN
C
C     construct a format appropriate to the prompt string
      DIGIT=L/10
      FMT(2)=NUMERL(1+DIGIT)
      DIGIT=L-10*DIGIT
      FMT(3)=NUMERL(1+DIGIT)
C
C     write the prompt string
      WRITE(0,FMT) (MSG(K),K=1,L)
      RETURN
      END
