C
Code by Michael Kupferschmid
C
      FUNCTION QUERY(STRING,LS)
C     This routine writes the string STRING, of length LS, on
C     standard error and reads a yes or no response from
C     standard in.
C
C     variable  quantity
C     --------  --------
C     L         length of response
C     LENGTH    function returns index of last nonblank in a string
C     LS        number of characters in STRING
C     MESAGE    routine writes a message on standard error
C     N         index on recognized responses
C     PROMPT    routine prompts for input from the terminal
C     SHIFTL    routine removes leading blanks from a string
C     STRING    the question to ask
C     UPSTR     routine upper-cases a string
C     YESNO     table of recognized responses
C     YORN      the answer given
C
      LOGICAL*4 QUERY
      CHARACTER*1 STRING(LS),YORN(80)
      CHARACTER*1 YESNO(3,8)/
     ;            'Y',' ',' ',
     ;            'Y','E','S',
     ;            'Y','E',' ',
     ;            'O','K',' ',
     ;            'T',' ',' ',
     ;            'N',' ',' ',
     ;            'N','O',' ',
     ;            'F',' ',' '/
C
C ------------------------------------------------------------------
C
C     write the question
    4 CALL PROMPT(STRING,LS)
C
C     read the response
      QUERY=.FALSE.
      READ(5,901,END=1) YORN
  901 FORMAT(80A1)
C
C     if the response is too long or too short, complain
      CALL SHIFTL(YORN,80)
      L=LENGTH(YORN,80)
      IF(L.EQ.0 .OR. L.GT.3) GO TO 2
C
C     interpret the response
      CALL UPSTR(YORN,L)
      DO 3 N=1,8
           IF(YORN(1).NE.YESNO(1,N)) GO TO 3
           IF(YORN(2).NE.YESNO(2,N)) GO TO 3
           IF(YORN(3).NE.YESNO(3,N)) GO TO 3
C
C          an acceptable response has been found
           IF(N.LE.5) QUERY=.TRUE.
           RETURN
    3 CONTINUE
C
C     the response was not a yes or a no; complain and try again
    2 CALL MESAGE('What?  Please answer yes or no.',31)
      GO TO 4
C
C     the user sent an end-of-file
    1 CALL MESAGE('EOF',3)
      STOP
      END
