C
Code by Michael Kupferschmid
C
      SUBROUTINE R82TPV(R,TPV,L)
C     This routine returns the two-part value corresponding to R.
C
C     variable  meaning
C     --------  -------
C     DFLOAT    Fortran function gives REAL*8 for INTEGER*4
C     IFIX      Fortran function gives INTEGER*4 for REAL*4
C     L         number of small things in a big one
C     R         the REAL*8 to be converted to a two-part value
C     SNGL      Fortran function gives REAL*4 for REAL*8
C     T         fractional part as a REAL*8
C     TPV       the result two-part value
C     TPVNML    routine normalizes a two-part value
C
      REAL*8 R,T 
      INTEGER*4 TPV(2)
C
C ------------------------------------------------------------------
C
C     put the whole-number part of R in TPV(1)
      TPV(1)=IFIX(SNGL(R))
C
C     put the fraction in TPV(2)
      T=DFLOAT(L)*(R-DFLOAT(TPV(1)))
      IF(T.GE.0.D0) TPV(2)=IFIX(SNGL(T)+0.5)
      IF(T.LT.0.D0) TPV(2)=IFIX(SNGL(T)-0.5)
C
C     normalize the result
      CALL TPVNML(TPV,L)
      RETURN
      END
