C
Code by Michael Kupferschmid
C
      SUBROUTINE SHFTKN(STRING,LS,NTSL,RC)
C     This routine shifts the contents of STRING left NTSL tokens.
C
C     RC  meaning
C     --  -------
C      0  all went well
C      1  fewer than NTSL tokens were found
C      2  input parameters did not make sense
C
C     variable  meaning
C     --------  -------
C     ITSL      number of tokens by which STRING is shifted left
C     K         index on the characters of STRING
C     L         index of last nonblank in STRING
C     LENGTH    function returns index of last nonblank in a string
C     LS        number of characters in STRING
C     NTSL      number of tokens to left-shift STRING by
C     RC        return code; see table above
C     SHIFTL    routine shifts left by a given number of characters
C     STRING    the string to be manipulated
C
      CHARACTER*1 STRING(LS)
      INTEGER*4 RC
C
C ------------------------------------------------------------------
C
C     check for sensible inputs and position to first token
      RC=0
      IF(LS.LT.0) RC=2
      IF(NTSL.LT.0) RC=2
      IF(NTSL.EQ.0) RETURN
      CALL SHIFTL(STRING,LS)
      L=LENGTH(STRING,LS)
      IF(L.EQ.0) RC=1
      IF(RC.NE.0) RETURN
C
C     to begin with no token shifts have been done
      ITSL=0
C     
C     blank out this token until reaching its end
    3 DO 1 K=1,L
           KB=K
           IF(STRING(K).EQ.' ') GO TO 2 
           STRING(K)=' '
    1 CONTINUE
C
C     shift out the blanks
    2 CALL SHIFTL(STRING,L)
      L=L-KB
      ITSL=ITSL+1
C
C     have we shifted out the required number of tokens?
      IF(ITSL.EQ.NTSL) RETURN
C
C     no; go to do another one
      IF(L.GT.0) GO TO 3 
      RC=1
      RETURN
      END
