C
Code by Michael Kupferschmid
C
      SUBROUTINE SHIFTL(STRING,L)
C     This routine left-justifies the nonblank characters in
C     STRING, moving blanks from before to after them.
C
C     variable  meaning
C     --------  -------
C     K         index on the characters of STRING
C     KFNB      index of first nonblank in unjustified STRING
C     L         number of characters in STRING, including blanks
C     STRING    the characer string to be left-justified
C
      CHARACTER*1 STRING(L)
C
C ------------------------------------------------------------------
C
C     find the leftmost nonblank
      IF(L.LT.2) RETURN
      DO 1 K=1,L
           IF(STRING(K).EQ.' ') GO TO 1
           KFNB=K
           GO TO 2
    1 CONTINUE
C     the string is all blanks
      RETURN
C
C     is the first nonblank the first character?
    2 IF(KFNB.EQ.1) RETURN
C
C     no; copy the string left to remove leading blanks
      DO 3 K=KFNB,L
           STRING(K-KFNB+1)=STRING(K)
    3 CONTINUE
C
C     blank out the end characters that were shifted
      DO 4 K=L-KFNB+2,L
           STRING(K)=' '
    4 CONTINUE
      RETURN
      END
