C 
Code by Michael Kupferschmid
C 
      SUBROUTINE SHIFTR(STRING,L) 
C     This routine right-justifies the nonblank characters in
C     STRING, moving blanks from after to before them.
C 
C     variable  quantity 
C     --------  -------- 
C     K         index on the characters of STRING 
C     KLNB      index of last nonblank in unjustified STRING 
C     L         number of characters in STRING, including blanks
C     STRING    the character string to be right-justified 
C 
      CHARACTER*1 STRING(L)
C 
C ------------------------------------------------------------------
C 
C     find the rightmost nonblank
      IF(L.LT.2) RETURN
      DO 1 K=1,L
           KLNB=L-K+1 
           IF(STRING(KLNB).NE.' ') GO TO 2 
    1 CONTINUE 
C     the string is all blanks
      RETURN 
C 
C     is the last nonblank the last character?
    2 IF(KLNB.EQ.L) RETURN 
C 
C     no; copy the string right to remove trailing blanks
      DO 3 K=1,KLNB 
           STRING(L-K+1)=STRING(KLNB-K+1) 
    3 CONTINUE
C 
C     blank out the front characters that were shifted 
      DO 4 K=1,L-KLNB
           STRING(K)=' '
    4 CONTINUE
      RETURN 
      END 
