C
Code by Nancy and Michael Kupferschmid
C
      SUBROUTINE SORTI4(N,LIST,LORD)
C     This routine sorts LIST into increasing order by insertion.
C
C     variable  meaning
C     --------  -------
C     I         index on LIST elements going down
C     J         index on LIST elements going up
C     JTEMP     where to put the element that is out of order
C     LIST      the list of integers to be sorted
C     LORD      permutation of original order
C     LTEMP     the element that is out of order
C     N         number of items in LIST
C     OTEMP     temporary for rearranging LORD
C
      INTEGER*4 LIST(N),LORD(N),OTEMP
C
C ------------------------------------------------------------------
C
C     check for sensible parameter
      IF(N .LT. 1) RETURN
      DO 4 I=1,N
           LORD(I)=I
    4 CONTINUE
      IF(N .EQ. 1) RETURN
C
C     consider each element
      DO 1 I=2,N
C          if this element is in order leave it where it is
           IF(LIST(I) .GE. LIST(I-1)) GO TO 1
C
C          found an element that is out of order
           LTEMP=LIST(I)
           OTEMP=LORD(I)
C
C          buttle a place for it up
           DO 2 J=I-1,1,-1
                IF(LIST(J) .GT. LTEMP) THEN
C                  by moving higher and higher elements above I down
                   LIST(J+1)=LIST(J)
                   LORD(J+1)=LORD(J)
                ELSE
C                  until finding where the out of place element goes
                   JTEMP=J+1
                   GO TO 3
                ENDIF
    2      CONTINUE
           JTEMP=1
C
C          insert the element in the right place
    3      LIST(JTEMP)=LTEMP
           LORD(JTEMP)=OTEMP
    1 CONTINUE
C
      RETURN
      END
