C
Code by Michael Kupferschmid
C
      SUBROUTINE SORTR8(N, X)
C     This routine sorts X into increasing order by insertion.
C
C     variable  meaning
C     --------  -------
C     I         index on X elements going down
C     J         index on X elements going up
C     JTEMP     where to put the element that is out of order
C     XTEMP     the element that is out of order
C     N         the number of values in X
C     X         the vector of values to be sorted
C
      REAL*8 X(N),XTEMP
C
C ------------------------------------------------------------------
C
C     check for sensible parameter
      IF(N.LE.1) RETURN
C
C     consider each element
      DO 1 I=2,N
C          if this element is in order leave it where it is
           IF(X(I) .GE. X(I-1)) GO TO 1
C
C          found an element that is out of order
           XTEMP=X(I)
C
C          bubble a place for it up
           DO 2 J=I-1,1,-1
                IF(X(J) .GT. XTEMP) THEN
C                  by moving higher and higher elements above I down
                   X(J+1)=X(J)
                ELSE
C                  until finding where the out of place element goes
                   JTEMP=J+1
                   GO TO 3
                ENDIF
    2      CONTINUE
           JTEMP=1
C
C          insert the element in the right place
    3      X(JTEMP)=XTEMP
    1 CONTINUE
C
      RETURN
      END
