C
Code by Michael Kupferschmid
C
      SUBROUTINE SPACEL(STRING,L)
C     This routine shifts the characters in STRING so that the first
C     character is nonblank and all spaces are single.
C
C     variable  quantity
C     --------  --------
C     I         index on a source character of STRING
C     J         index on a target location of STRING
C     L         number of characters in STRING
C     SHIFTL    routine shifts leading blanks out of STRING
C     STRING    character string to be spaced left
C
      CHARACTER*1 STRING(L)
C
C ------------------------------------------------------------------
C
C     remove leading blanks from STRING, changing nothing else
      CALL SHIFTL(STRING,L)
C
C     copy the string to the left, ignoring multiple blanks
      J=1
      DO 1 I=2,L
C          is this character a blank?
           IF(STRING(I).NE.' ') GO TO 2
C
C          this character is a blank; was the previous?
           IF(STRING(I-1).NE.' ') GO TO 2
C
C          both this character and the previous character are blanks
           GO TO 1
C
    2      J=J+1 
           STRING(J)=STRING(I)
    1 CONTINUE
C
C     fill the end of the string with blanks
      IF(J.EQ.L) RETURN
      DO 3 J=J+1,L
           STRING(J)=' '
    3 CONTINUE
      RETURN
      END
