C
Code by Michael Kupferschmid
C
      SUBROUTINE STRCPY(SOURCE,LS,LT,JOB, TARGET)
C     This routine copies characters from SOURCE to TARGET.
C
C     JOB  behavior
C     ---  --------
C      0   leave alone the characters not copied over in TARGET
C      1   blank out the characters not copied over in TARGET
C
C     variable  meaning
C     --------  -------
C     BLANK     the character ' '
C     JOB       task to perform; see table above
C     K         index on the characters in the strings
C     L         number of characters copied from SOURCE to TARGET
C     LS        number of characters in SOURCE
C     LT        number of characters in TARGET
C     MIN0      Fortran function returns smaller of INTEGER*4s
C     SOURCE    character string from which to copy
C     TARGET    character string to which to copy
C
      CHARACTER*1 SOURCE(LS),TARGET(LT),BLANK/' '/
C
C ------------------------------------------------------------------
C
C     figure out how many characters to copy
      L=MIN0(LS,LT)
C
C     overwrite TARGET characters from SOURCE
      DO 1 K=1,L
           TARGET(K)=SOURCE(K)
    1 CONTINUE
C
C     blank out leftover TARGET characters if required
      IF(JOB.EQ.0 .OR. LS.GE.LT) RETURN
      DO 2 K=LS+1,LT
           TARGET(K)=BLANK
    2 CONTINUE
      RETURN
      END
