C
Code by Michael Kupferschmid
C
      SUBROUTINE STRINS(STRING,LS,INSERT,LIIN,LOC,JOB, RESULT,LR)
C     This routine inserts one string in another, starting at
C     location LOC.
C
C     JOB  spacing
C     ---  -------
C      0   leave spacing unchanged
C      1   leave 1 blank at the end of the insert
C      2   leave no blanks at the end of the insert
C
C     variable  meaning
C     --------  -------
C     INSERT    string to be inserted
C     JOB       what to do about spacing; see table above
C     K         index on the characters of a string
C     L         index in RESULT of rightmost unshifted character
C     LENGTH    function returns index of last nonblank in a string
C     LI        number of characters used from INSERT
C     LIIN      number of characters provided in INSERT
C     LOC       where in STRING to insert INSERT
C     LR        index of the last nonblank in RESULT
C     LS        number of characters in STRING
C     MIN0      Fortran function gives smaller of INTEGER*4s
C     RESULT    result string
C     SHIFTL    routine removes leading blanks from a string
C     STRING    template string
C
      CHARACTER*1 STRING(LS),INSERT(LIIN),RESULT(*)
C
C ------------------------------------------------------------------
C
C     can't insert into an empty string
      IF(LS.LE.0) THEN
         LR=0
         RETURN
      ENDIF
C
C     copy the template into the result
      DO 1 K=1,LS
           RESULT(K)=STRING(K)
    1 CONTINUE
      LR=LS
C
C     can't insert outside the template
      IF(LOC.LE.0 .OR. LOC.GT.LS) RETURN
C
C     insert as much of the insertion as will fit, starting at LOC
      LI=MIN0(LIIN,LS-LOC+1)
      IF(LI.LE.0) RETURN
      DO 2 K=1,LI
           RESULT(LOC+K-1)=INSERT(K)
    2 CONTINUE
C
C     do the requested spacing
      IF(JOB.NE.1 .AND. JOB.NE.2) GO TO 3
      L=LOC+LI-(JOB-1)
      IF(LS.GT.L) CALL SHIFTL(RESULT(L+1),LS-L)
    3 LR=LENGTH(RESULT,LS)
      RETURN
      END
