C
Code by Michael Kupferschmid
C
      SUBROUTINE TKNIZE(STRING,LS,MXLT,MXNT, TKNS,NT,RC)
C     This routine extracts the tokens in STRING.
C
C     RC  meaning
C     --  --------------------
C      0  all went well
C      1  no tokens
C      2  too many tokens
C      3  a token was too long
C
C     variable  meaning
C     --------  -------
C     J         index on tokens
C     K         index on the characters of a string
C     KSTART    starting index in STRING of this token
C     KT        index on the elements of a token
C     L         index of last nonblank in STRING
C     LENGTH    function returns index of last nonblank in a string
C     LS        number of characters in STRING
C     MXLT      maximum length allowed for a token
C     MXNT      maximum number of tokens allowed
C     NT        number of tokens found
C     RC        return code; 0 => all went well
C     SPACEL    routine removes leading and extra blanks
C     STRING    the string to tokenize
C     TKNS      the extracted tokens
C
C     formal parameters
      CHARACTER*1 STRING(LS),TKNS(MXLT,MXNT)
      INTEGER*4 RC
C
C     automatic workspace
      CHARACTER*1 WORK(LS)
C
C ------------------------------------------------------------------
C
C     initialize TKNS to blanks
      DO 1 J=1,MXNT
           DO 2 K=1,MXLT
                TKNS(K,J)=' '
    2      CONTINUE
    1 CONTINUE
C
C     remove leading and extra blanks from the input string
      CALL STRCPY(STRING,LS,LS,0, WORK)
      CALL SPACEL(WORK,LS)
      L=LENGTH(WORK,LS)
C
C     report if the input string is empty, or prepare to parse it
      IF(L.EQ.0) THEN
         NT=0
         RC=1
         RETURN
      ELSE
         NT=1
         RC=0
         K=0
         KSTART=1
      ENDIF
C
C     copy out the blank-separated tokens 
    3 K=K+1           
      IF(WORK(K).EQ.' ') THEN
         NT=NT+1
         IF(NT.GT.MXNT) THEN
            RC=2
            RETURN
         ENDIF
         KSTART=K+1
      ELSE
         KT=K-KSTART+1
         IF(KT.GT.MXLT) THEN
            RC=3
            RETURN
         ENDIF
         TKNS(KT,NT)=WORK(K)
      ENDIF
      IF(K.LT.L) GO TO 3
C
C     the end of the input string has been reached
      RETURN
      END
