C
Code by Michael Kupferschmid
C
      SUBROUTINE TPVNML(TPV,L)
C     This routine normalizes the two-part value TPV.
C
C     variable  meaning
C     --------  -------
C     BIGS      number of big things among the smalls
C     L         number of small things in a big one
C     SMALLS    number of small things moved to the BIGS slot
C     TPV       the two-part value to be normalized
C
      INTEGER*4 TPV(2),BIGS,SMALLS
C
C ------------------------------------------------------------------
C
C     move L's of SMALLs from the SMALLS slot to the BIGS slot
      BIGS=TPV(2)/L
      TPV(1)=TPV(1)+BIGS
      SMALLS=L*BIGS
      TPV(2)=TPV(2)-SMALLS
C
C     make the signs the same 
      IF(TPV(1).GT.0 .AND. TPV(2).LT.0) THEN
         TPV(1)=TPV(1)-1
         TPV(2)=TPV(2)+L
      ENDIF
      IF(TPV(1).LT.0 .AND. TPV(2).GT.0) THEN
         TPV(1)=TPV(1)+1
         TPV(2)=TPV(2)-L
      ENDIF
      RETURN
      END
