C
Code by Michael Kupferschmid
C
      SUBROUTINE TPVSCL(TPV,L,S)
C     This routine scales the two-part value TPV by factor S.
C
C     variable  meaning
C     --------  -------
C     L         number of small things in a big one
C     R82TPV    routine converts a REAL*8 to two-part value
C     S         the scale factor
C     T         the scaled value as a REAL*8
C     TPV       the two-part value to be scaled
C     TPV2R8    function gives REAL*8 for a two-part value
C
      INTEGER*4 TPV(2)
      REAL*8 S,T,TPV2R8
C
C ------------------------------------------------------------------
C
C     convert TPV to a REAL*8 and scale it
      T=S*TPV2R8(TPV,L)
C
C     convert the result back to a two-part value
      CALL R82TPV(T,TPV,L)
      RETURN
      END
