C
Code by Michael Kupferschmid
C
      FUNCTION TRNIDX(TRN,TRAN,NWD)
C     This function returns the index in TRAN of TRN, or 0.
C
C     variable  meaning
C     --------  -------
C     BOT       low index in bisection
C     I         trial index
C     ITR       midpoint of top and bottom indices
C     NWD       number of words in the list
C     TOP       high index in bisection
C     TRAN      list of transliterations
C     TRN       transliteration whose index is sought
C
C     formal parameters
      INTEGER*4 TRNIDX
      CHARACTER*18 TRN,TRAN(NWD)
C
C     local variables
      INTEGER*4 TOP,BOT
C
C ------------------------------------------------------------------
C
C     start looking at the middle of the sorted list
      TOP=1
      BOT=NWD
      ITR=(TOP+BOT)/2
C
C     is this the word that is sought?
    1 I=ITR
      IF(TRN.EQ.TRAN(I)) THEN
C        yes; return its index
         TRNIDX=I
         RETURN
      ELSE
C       no; bisect the interval containing the word
        IF(TRN.GT.TRAN(I)) THEN
           TOP=I
        ELSE
           BOT=I
        ENDIF
      ENDIF
      ITR=(TOP+BOT)/2
C
C     is this guess the same as the last one?
      IF(ITR.EQ.I) THEN
C        yes; either the word sought is at an end of the interval
         IF(TRN.EQ.TRAN(TOP)) THEN
            TRNIDX=TOP
            RETURN
         ENDIF
         IF(TRN.EQ.TRAN(BOT)) THEN
            TRNIDX=BOT
            RETURN
         ENDIF
C
C        or it is not on the list
         TRNIDX=0
         RETURN
      ENDIF
C
C     continue bisecting until a match is found or ruled out
      GO TO 1
      END
