C
Code by Michael Kupferschmid
C
      SUBROUTINE UNCTLD(RC)
C     This routine reestablishes unit 5 as the keyboard after EOF.
C
C     RC  meaning
C     --  -------
C      0  all went well; unit 5 was closed and reopened
C      1  unit 5 was attached to a file; unit 5 was closed
C      2  unit 5 was already closed; nothing was done
C      3  unit 5 was a redirect or pipe target; unit 5 was closed
C
C     variable  meaning
C     --------  -------
C     FYLE      the file or device name to which unit 5 is attached
C     NAM       the first 5 characters of FYLE
C     RC        return code; see table above
C
C     formal parameter
      INTEGER*4 RC
C
C     overlay to extract the first 5 characters of FYLE
      CHARACTER*24 FYLE
      CHARACTER*5 NAM
      EQUIVALENCE(FYLE,NAM)
C
C ------------------------------------------------------------------
C
C     where is unit 5 attached now?
      INQUIRE(UNIT=5,NAME=FYLE)
      IF(NAM.EQ.'stdin') THEN
C        unit 5 is the target of a redirect or pipe
         CLOSE(5)
         RC=3
         RETURN
      ENDIF
      IF(NAM.EQ.'     ') THEN
C        unit 5 is closed
         RC=2
         RETURN
      ENDIF
      IF(NAM.NE.'/dev/') THEN
C        unit 5 is attached to a file
         CLOSE(5)
         RC=1
         RETURN
      ENDIF
C
C     unit 5 is attached to some /dev, presumably the keyboard
      CLOSE(5)
      OPEN(UNIT=5,FILE=FYLE)
      RC=0
      RETURN
      END
