C
Code by Michael Kupferschmid
C
      SUBROUTINE UNPUNC(STRING,LS)
C     This routine removes punctuation and parenthesized strings.
C
C     variable  meaning
C     --------  -------
C     INPAR     T => in a parenthesized string
C     J         index on punctuation characters
C     K         index on the characters of STRING
C     L         index of last nonblank in STRING
C     LENGTH    function returns index of last nonblank in a string
C     LS        dimensioned length of STRING
C     PUNC      ~`!@#$%^&*-_=+[{]}\|;:'",<.>/?
C     SPACEL    routine removes leading and extra blanks
C     STRING    input text to be edited
C
C     formal parameters
      CHARACTER*1 STRING(LS)
C
C     local variables
      LOGICAL*4 INPAR 
      CHARACTER*1 PUNC(29)/'~','`','!','@','#','$','%','^','&','*',
     ;                     '-','_','=','+','[','{',']','}','\','|',
     ;                     ';',':','"',',','<','.','>','/','?'/
C
C ------------------------------------------------------------------
C
C     if the input string is empty there is nothing to do
      L=LENGTH(STRING,LS)
      IF(L.EQ.0) RETURN
C
C     blank out parenthesized substrings
      INPAR=.FALSE.
      DO 1 K=1,L
           IF(STRING(K).EQ.')') THEN
              STRING(K)=' '
              INPAR=.FALSE.
           ENDIF
           IF(STRING(K).EQ.'(') INPAR=.TRUE.
           IF(INPAR) STRING(K)=' '
    1 CONTINUE
C
C     blank out ' characters not denoting contraction
      IF(L.LT.3) GO TO 2
      DO 3 K=2,L-1
           IF(STRING(K).EQ."'") THEN
              IF(STRING(K-1).NE.' ' .AND.
     ;           STRING(K+1).NE.' ') GO TO 2
              STRING(K)=' '
           ENDIF
    3 CONTINUE
C
C     blank out other punctuation
    2 DO 4 K=1,L
           DO 5 J=1,29
                IF(STRING(K).EQ.PUNC(J)) STRING(K)=' '
    5      CONTINUE
    4 CONTINUE
C
C     remove leading and extra blanks
      CALL SPACEL(STRING,L)
      RETURN
      END
