C
Code by Michael Kupferschmid
C
      FUNCTION WKDAY(DAYNO)
C     This function returns the 3-character name of the
C     day of the week corresponding to the given day number.
C
C     variable  meaning
C     --------  -------
C     DAYNO     number of the day for which day of week is needed
C     IABS      Fortran function for |INTEGER*4|
C     MOD       Fortran function for remainder of integer division
C     NWKDAY    number of the day in the first week of the epoch
C
      CHARACTER*3 WKDAY
      INTEGER*4 DAYNO
C
C ------------------------------------------------------------------
C
C     01 Jan 70 was day 1, and that was a Thursday
      IF(DAYNO.GT.0) THEN
         NWKDAY=MOD(DAYNO,7)
         IF(NWKDAY.EQ.0) WKDAY='Wed'
         IF(NWKDAY.EQ.1) WKDAY='Thu'
         IF(NWKDAY.EQ.2) WKDAY='Fri'
         IF(NWKDAY.EQ.3) WKDAY='Sat'
         IF(NWKDAY.EQ.4) WKDAY='Sun'
         IF(NWKDAY.EQ.5) WKDAY='Mon'
         IF(NWKDAY.EQ.6) WKDAY='Tue'
      ELSE
C        day -1 is 31 Dec 69, and that was a Wednesday
         NWKDAY=MOD(IABS(DAYNO+1),7)
         IF(NWKDAY.EQ.0) WKDAY='Wed'
         IF(NWKDAY.EQ.1) WKDAY='Tue'
         IF(NWKDAY.EQ.2) WKDAY='Mon'
         IF(NWKDAY.EQ.3) WKDAY='Sun'
         IF(NWKDAY.EQ.4) WKDAY='Sat'
         IF(NWKDAY.EQ.5) WKDAY='Fri'
         IF(NWKDAY.EQ.6) WKDAY='Thu'
      ENDIF
      RETURN
      END
